[llvm-commits] [llvm-gcc-4.2] r43056 - /llvm-gcc-4.2/trunk/build_gcc

Devang Patel dpatel at apple.com
Tue Oct 16 17:07:16 PDT 2007


Author: dpatel
Date: Tue Oct 16 19:07:16 2007
New Revision: 43056

URL: http://llvm.org/viewvc/llvm-project?rev=43056&view=rev
Log:
Simplify. Use installed llvm.

Modified:
    llvm-gcc-4.2/trunk/build_gcc

Modified: llvm-gcc-4.2/trunk/build_gcc
URL: http://llvm.org/viewvc/llvm-project/llvm-gcc-4.2/trunk/build_gcc?rev=43056&r1=43055&r2=43056&view=diff

==============================================================================
--- llvm-gcc-4.2/trunk/build_gcc (original)
+++ llvm-gcc-4.2/trunk/build_gcc Tue Oct 16 19:07:16 2007
@@ -22,22 +22,8 @@
 # installed.
 TARGETS=`echo $2 | $TRANSLATE_ARCH`
 
-#LLVM LOCAL begin
-# LLVM does not require host name translation. 
-LLVM_HOSTS=$1
-# LLVM target list is comma separated list. 
-#LLVM_TARGETS=`echo $2 | sed -e s/\ /\,/ -e s/ppc/powerpc/ -e s/i386/x86/ \
-#    -e s/x86_64// -e s/powerpc64// -e s/ppc64//`
-#FIXME : Hard code targets. See LLVMTARGETOBJ comment in gcc/Makefile.in
-LLVM_TARGETS="x86,powerpc"
-#LLVM LOCAL end
-
 # The GNU makefile target ('bootstrap' by default).
-if [ "x$LLVM_DEBUG" == "x" ]; then
-    BOOTSTRAP=${BOOTSTRAP-bootstrap}
-else
-    BOOTSTRAP=
-fi
+BOOTSTRAP=${BOOTSTRAP-bootstrap}
 if [ "$BOOTSTRAP" != bootstrap ]; then
     bootstrap=--disable-bootstrap
 fi
@@ -47,13 +33,7 @@
 # $RC_NONARCH_CFLAGS (and mysteriously prepends '-pipe' thereto).
 # We will allow this to override the default $CFLAGS and $CXXFLAGS.
 
-if [ "x$LLVM_DEBUG" == "x" ]; then
-    CFLAGS="-g -O2 ${RC_NONARCH_CFLAGS/-pipe/}"
-    OPTIMIZE_OPTS="ENABLE_OPTIMIZED=1"
-else
-    CFLAGS="-g"
-    OPTIMIZE_OPTS=
-fi
+CFLAGS="-g -O2 ${RC_NONARCH_CFLAGS/-pipe/}"
 
 # This isn't a parameter; it is the architecture of the current machine.
 BUILD=`arch | $TRANSLATE_ARCH`
@@ -83,26 +63,15 @@
 ENABLE_LLVM="$7"
 
 # The eighth parameter is the version number of the submission, e.g. 1007.
-LLVM_SUBMIT_VERSION="$8"
+LLVM_GCC_SUBMIT_VERSION="$8"
 
 # The nineth parameter is the subversion number of the submission, e.g. 03.
-LLVM_SUBMIT_SUBVERSION="$9"
-
-# The tenth parameter is a yes/no that indicates whether assertions should be
-# enabled in the LLVM libs/tools.
-LLVM_ASSERTIONS="${10}"
+LLVM_GCC_SUBMIT_SUBVERSION="$9"
 
 # LLVM_INSTALL_PREFIX - This is the prefix where LLVM tools/headers/libraries
 # and the llvm-gcc/llvm-g++ symlinks get installed.
 LLVM_INSTALL_PREFIX=/usr/local
 
-# LLVM_ARCHS - This tells us which architectures we'd like the libraries to be
-# build for. The default is 4-way.
-if [ "x$LLVM_ARCHS" == "x" ]; then
-    LLVM_ARCHS="ppc i386 ppc64 x86_64"
-fi
-
-# LLVM LOCAL end
 
 # The current working directory is where the build will happen.
 # It may already contain a partial result of an interrupted build,
@@ -127,6 +96,7 @@
   MAJ_VERS="${MAJ_VERS}-llvm"
 fi
 # LLVM LOCAL end
+
 # This is the libstdc++ version to use.
 LIBSTDCXX_VERSION=4.0.0
 
@@ -147,72 +117,25 @@
 mkdir $SRC_DIR || exit 1
 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
 rm -rf $SRC_DIR/tcl $SRC_DIR/expect $SRC_DIR/dejagnu || exit 1
-
-# LLVM LOCAL begin Must build libstdc++ to install in /usr/local.
-LIBSTDCXX_CONFIG_OPTION=
 # Also remove libstdc++ since it is built from a separate project.
 rm -rf $SRC_DIR/libstdc++-v3 || exit 1
-LIBSTDCXX_CONFIG_OPTION="--with-gxx-include-dir=/usr/include/c++/$LIBSTDCXX_VERSION"
-
-if [ "$ENABLE_LLVM" == false ]; then
-  # Clean out old specs files
-  rm -f /usr/lib/gcc/*/4.0.0/specs
-fi
-# LLVM LOCAL end
+# Clean out old specs files
+rm -f /usr/lib/gcc/*/4.0.0/specs
 
 # These are the configure and build flags that are used.
-# LLVM LOCAL begin  Support for non /usr $DEST_ROOT, use libstdc++
-
-if [ "x$LLVM_DEBUG" == "x" ]; then
-    CHECKING_FLAGS="--disable-checking --enable-werror"
-else
-    CHECKING_FLAGS="--enable-checking"
-fi
-
-CONFIGFLAGS="$CHECKING_FLAGS \
+CONFIGFLAGS="--disable-checking -enable-werror \
   --prefix=$DEST_ROOT \
-  --mandir=$LLVM_INSTALL_PREFIX/share/man \
+  --mandir=\${prefix}/share/man \
   --enable-languages=c,objc,c++,obj-c++ \
   --program-transform-name=/^[cg][^.-]*$/s/$/-$MAJ_VERS/ \
-  $LIBSTDCXX_CONFIG_OPTION \
+  --with-gxx-include-dir=\${prefix}/include/c++/$LIBSTDCXX_VERSION \
   --with-slibdir=/usr/lib \
   --build=$BUILD-apple-darwin$DARWIN_VERS"
-# LLVM LOCAL end
 
 # LLVM LOCAL begin
 if [ "$ENABLE_LLVM" == true ]; then
-  CONFIGFLAGS="$CONFIGFLAGS --enable-llvm=$DIR/obj-llvm"
-
-  # Build the LLVM tree universal.
-  LLVMCONFIGFLAGS="--prefix=$DEST_DIR$LLVM_INSTALL_PREFIX \
-                   --enable-targets=$LLVM_TARGETS \
-                   --enable-assertions=$LLVM_ASSERTIONS"
-  mkdir -p $DIR/obj-llvm || exit 1
-  cd $DIR/obj-llvm || exit 1
-  if [ \! -f Makefile.config ]; then
-   $SRC_DIR/llvm/configure $LLVMCONFIGFLAGS || exit 1
-  fi
-
-  if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
-   LLVM_VERSION="$LLVM_SUBMIT_VERSION"
-  else
-   LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
-  fi
-
-  # Note: Don't pass -jN here.  Building universal already has parallelism and
-  # we don't want to make the builders hit swap by firing off too many gcc's at
-  # the same time.
-  ## FIXME: Remove -O2 when rdar://4560645 is fixed.
-  make $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$LLVM_ARCHS" \
-       OPTIMIZE_OPTION='-O2' \
-       CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
-
-  if ! test $? == 0 ; then
-      echo "error: LLVM 'make' failed!"
-      exit 1
-  fi 
+  CONFIGFLAGS="$CONFIGFLAGS --enable-llvm=/usr/local"
 fi
-# LLVM LOCAL end
 
 # Figure out how many make processes to run.
 SYSCTL=`sysctl -n hw.activecpu`
@@ -236,11 +159,7 @@
 if [ "$ENABLE_LLVM" == true ]; then
   # Build llvm-gcc in 'dylib mode'.
   MAKEFLAGS="$MAKEFLAGS BUILD_LLVM_INTO_A_DYLIB=1"
-  MAKEFLAGS="$MAKEFLAGS LLVM_VERSION_INFO=$LLVM_SUBMIT_VERSION"
-
-  if [ "$LLVM_ASSERTIONS" == no ]; then
-    MAKEFLAGS="$MAKEFLAGS DISABLE_LLVMASSERTIONS=1"
-  fi
+  MAKEFLAGS="$MAKEFLAGS LLVM_VERSION_INFO=$LLVM_GCC_SUBMIT_VERSION"
 fi
 # LLVM LOCAL end
 
@@ -253,10 +172,8 @@
    --host=$BUILD-apple-darwin$DARWIN_VERS --target=$BUILD-apple-darwin$DARWIN_VERS || exit 1
 fi
 # Unset RC_DEBUG_OPTIONS because it causes the bootstrap to fail.
-# Also keep unset for cross compilers so that the cross built libraries are
-# comparable to the native built libraries.
-unset RC_DEBUG_OPTIONS
-make $MAKEFLAGS CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
+RC_DEBUG_OPTIONS= \
+  make $MAKEFLAGS CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
 make $MAKEFLAGS html CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
 make $MAKEFLAGS DESTDIR=$DIR/dst-$BUILD-$BUILD install-gcc install-target \
   CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
@@ -300,18 +217,14 @@
   mkdir -p $DIR/obj-$BUILD-$t $DIR/dst-$BUILD-$t || exit 1
    cd $DIR/obj-$BUILD-$t || exit 1
    if [ \! -f Makefile ]; then
-    if [ "x$LLVM_DEBUG" == "x" ]; then
-     WERROR_FLAGS="--enable-werror-always"
-    else
-     WERROR_FLAGS=""
-    fi
-    $SRC_DIR/configure $CONFIGFLAGS $WERROR_FLAGS \
+    $SRC_DIR/configure $CONFIGFLAGS --enable-werror-always \
       --program-prefix=$t-apple-darwin$DARWIN_VERS- \
       --host=$BUILD-apple-darwin$DARWIN_VERS --target=$t-apple-darwin$DARWIN_VERS || exit 1
    fi
    make $MAKEFLAGS all CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
    make $MAKEFLAGS DESTDIR=$DIR/dst-$BUILD-$t install-gcc install-target \
      CFLAGS="$CFLAGS" CXXFLAGS="$CFLAGS" || exit 1
+
     # Add the compiler we just built to the path.
 # LLVM LOCAL  Support for non /usr $DEST_ROOT
    PATH=$DIR/dst-$BUILD-$t/$DEST_ROOT/bin:$PATH
@@ -373,38 +286,32 @@
 HTMLDIR="/Developer/Documentation/DocSets/com.apple.ADC_Reference_Library.DeveloperTools.docset/Contents/Resources/Documents/documentation/DeveloperTools"
 mkdir -p ".$HTMLDIR" || exit 1
 cp -Rp $DIR/obj-$BUILD-$BUILD/gcc/HTML/* ".$HTMLDIR/" || exit 1
+fi
 
 # Manual pages
-mkdir -p .$LLVM_INSTALL_PREFIX/share || exit 1
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-cp -Rp $DIR/dst-$BUILD-$BUILD$LLVM_INSTALL_PREFIX/share/man .$LLVM_INSTALL_PREFIX/share/ \
+mkdir -p .$DEST_ROOT/share || exit 1
+cp -Rp $DIR/dst-$BUILD-$BUILD$DEST_ROOT/share/man .$DEST_ROOT/share/ \
   || exit 1
 # exclude fsf-funding.7 gfdl.7 gpl.7 as they are currently built in
 # the gcc project
 rm -rf .$DEST_ROOT/share/man/man7
 
 # libexec
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-cd $DIR/dst-$BUILD-$BUILD/$DEST_ROOT/libexec/gcc/$BUILD-apple-darwin$DARWIN_VERS/$VERS \
+cd $DIR/dst-$BUILD-$BUILD$DEST_ROOT/libexec/gcc/$BUILD-apple-darwin$DARWIN_VERS/$VERS \
   || exit 1
 LIBEXEC_FILES=`find . -type f -print || exit 1`
 LIBEXEC_DIRS=`find . -type d -print || exit 1`
 cd $DEST_DIR || exit 1
 for t in $TARGETS ; do
   DL=$DEST_ROOT/libexec/gcc/$t-apple-darwin$DARWIN_VERS/$VERS
-  # LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-  SL=/$DEST_ROOT/libexec/gcc/$t-apple-darwin$DARWIN_VERS/$VERS
   for d in $LIBEXEC_DIRS ; do
     mkdir -p .$DL/$d || exit 1
   done
   for f in $LIBEXEC_FILES ; do
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT, allow dynamically linked shared libs.
-    if file $DIR/dst-*-$t$SL/$f | grep -q -E 'Mach-O (executable|dynamically linked shared library)' ; then
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-      lipo -output .$DL/$f -create $DIR/dst-*-$t$SL/$f || exit 1
+    if file $DIR/dst-*-$t$DL/$f | grep -q 'Mach-O executable' ; then
+      lipo -output .$DL/$f -create $DIR/dst-*-$t$DL/$f || exit 1
     else
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-      cp -p $DIR/dst-$BUILD-$t$SL/$f .$DL/$f || exit 1
+      cp -p $DIR/dst-$BUILD-$t$DL/$f .$DL/$f || exit 1
     fi
   done
   ln -s ../../../../bin/as .$DL/as
@@ -416,31 +323,26 @@
 BIN_FILES=`ls $DIR/dst-$BUILD-$BUILD$DEST_ROOT/bin | grep '^[^-]*-[0-9.]*$' \
   | grep -v gccbug | grep -v gcov || exit 1`
 mkdir .$DEST_ROOT/bin
-for f in $BIN_FILES ; do 
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-  lipo -output .$DEST_ROOT/bin/$f -create $DIR/dst-*/$DEST_ROOT/bin/$f || exit 1
+for f in $BIN_FILES ; do
+  lipo -output .$DEST_ROOT/bin/$f -create $DIR/dst-*$DEST_ROOT/bin/$f || exit 1
 done
 # gcov, which is special only because it gets built multiple times and lipo
 # will complain if we try to add two architectures into the same output.
 TARG0=`echo $TARGETS | cut -d ' ' -f 1`
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
 lipo -output .$DEST_ROOT/bin/gcov-$MAJ_VERS -create \
-  $DIR/dst-*-$TARG0/$DEST_ROOT/bin/*gcov* || exit 1
+  $DIR/dst-*-$TARG0$DEST_ROOT/bin/*gcov* || exit 1
 # The fully-named drivers, which have the same target on every host.
 for t in $TARGETS ; do
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
   lipo -output .$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-gcc-$VERS -create \
-    $DIR/dst-*-$t/$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-gcc-$VERS || exit 1
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
+    $DIR/dst-*-$t$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-gcc-$VERS || exit 1
   lipo -output .$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-g++-$VERS -create \
-    $DIR/dst-*-$t/$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-g++* || exit 1
-  done
+    $DIR/dst-*-$t$DEST_ROOT/bin/$t-apple-darwin$DARWIN_VERS-g++* || exit 1
+done
 
 # lib
 mkdir -p .$DEST_ROOT/lib/gcc || exit 1
 for t in $TARGETS ; do
-# LLVM LOCAL build_gcc bug with non-/usr $DEST_ROOT
-  cp -Rp $DIR/dst-$BUILD-$t/$DEST_ROOT/lib/gcc/$t-apple-darwin$DARWIN_VERS \
+  cp -Rp $DIR/dst-$BUILD-$t$DEST_ROOT/lib/gcc/$t-apple-darwin$DARWIN_VERS \
     .$DEST_ROOT/lib/gcc || exit 1
 done
 
@@ -471,8 +373,7 @@
   cp -p /usr/lib/libstdc++.6.dylib \
     .$DEST_ROOT/lib/gcc/$t-apple-darwin$DARWIN_VERS/$VERS/libstdc++.dylib \
     || exit 1
-# LLVM LOCAL
-#  strip -x -c .$DEST_ROOT/lib/gcc/$t-apple-darwin$DARWIN_VERS/$VERS/libstdc++.dylib || exit 1
+  strip -x -c .$DEST_ROOT/lib/gcc/$t-apple-darwin$DARWIN_VERS/$VERS/libstdc++.dylib || exit 1
 done
 
 # include
@@ -500,7 +401,7 @@
 done
 
 # Add extra man page symlinks for 'c++' and for arch-specific names.
-MDIR=$DEST_DIR$LLVM_INSTALL_PREFIX/share/man/man1
+MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
 ln -f $MDIR/g++-$MAJ_VERS.1 $MDIR/c++-$MAJ_VERS.1 || exit 1
 for t in $TARGETS ; do
   ln -f $MDIR/gcc-$MAJ_VERS.1 $MDIR/$t-apple-darwin$DARWIN_VERS-gcc-$VERS.1 \
@@ -567,87 +468,11 @@
 ########################################
 # Remove debugging information from DEST_DIR.
 
-find $DEST_DIR -perm -0111 \! -name \*.dylib \! -name fixinc.sh \
+find $DEST_DIR -perm -0111 \! -name fixinc.sh \
     \! -name mkheaders \! -name libstdc++.dylib -type f -print \
   | xargs strip || exit 1
-# LLVM LOCAL begin - Strip with -Sx instead of -SX
-find $DEST_DIR \( -name \*.a -or -name \*.dylib \) \
-    \! -name libgcc_s.10.*.dylib -type f -print \
-  | xargs strip -SX || exit 1
-# LLVM LOCAL end - Strip with -Sx instead of -SX
-find $DEST_DIR -name \*.a -type f -print \
-  | xargs ranlib || exit 1
-
-# LLVM LOCAL begin
-# Install LLVM libraries/headers/tools.
-if [ "$ENABLE_LLVM" == true ]; then
-  cd $DIR/obj-llvm || exit 1
-
-  ## Install the tree into the destination directory.
-  make $MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 OPTIMIZE_OPTION='-O2' install
-
-  if ! test $? == 0 ; then
-      echo "error: LLVM 'make install' failed!"
-      exit 1
-  fi 
-
-  ## Install Version.h
-  if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
-      RC_ProjectSourceSubversion=0
-  else
-      case "$LLVM_SUBMIT_SUBVERSION" in
-          01) RC_ProjectSourceSubversion=1 ;;
-          02) RC_ProjectSourceSubversion=2 ;;
-          03) RC_ProjectSourceSubversion=3 ;;
-          04) RC_ProjectSourceSubversion=4 ;;
-          05) RC_ProjectSourceSubversion=5 ;;
-          06) RC_ProjectSourceSubversion=6 ;;
-          07) RC_ProjectSourceSubversion=7 ;;
-          08) RC_ProjectSourceSubversion=8 ;;
-          09) RC_ProjectSourceSubversion=9 ;;
-          *)  RC_ProjectSourceSubversion=$LLVM_SUBMIT_SUBVERSION ;;
-      esac
-  fi
-
-  echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$LLVM_INSTALL_PREFIX/include/llvm/Version.h
-  echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$LLVM_INSTALL_PREFIX/include/llvm/Version.h
-
-  ## Strip local symbols from llvm libraries.
-  strip -S $DEST_DIR$LLVM_INSTALL_PREFIX/lib/*.[oa]
-  strip -Sx $DEST_DIR$LLVM_INSTALL_PREFIX/lib/*.so
-
-  # Remove .dir files 
-  cd $DEST_DIR$LLVM_INSTALL_PREFIX/
-  rm bin/.dir etc/llvm/.dir lib/.dir
-
-  # Remove PPC64 fat slices.
-  cd $DEST_DIR$LLVM_INSTALL_PREFIX/bin
-if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
-  find . -perm 755 -type f -exec lipo -extract ppc -extract i386 {} -output {} \;
-else
-  find . -perm 755 -type f -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
-fi
-  cd $DEST_DIR$LLVM_INSTALL_PREFIX
-  lipo -extract ppc -extract i386 lib/LLVMlto.0.0.0.so -output lib/LLVMlto.0.0.0.so
-
-  # Set up the llvm-gcc/llvm-g++ symlinks.
-  cd $DEST_DIR$LLVM_INSTALL_PREFIX/bin
-  ln -s -f ../../../$DEST_ROOT/bin/gcc-$MAJ_VERS llvm-gcc || exit 1
-  ln -s -f ../../../$DEST_ROOT/bin/g++-$MAJ_VERS llvm-g++ || exit 1
-
-  # Copy one of the libllvmgcc.dylib's up to libexec/gcc.
-  cp $DEST_DIR/$DEST_ROOT/libexec/gcc/$BUILD-apple-darwin$DARWIN_VERS/$VERS/libllvmgcc.dylib \
-     $DEST_DIR/$DEST_ROOT/libexec/gcc/
-
-  # Replace the installed ones with symlinks to the common one.
-  for t in $TARGETS ; do
-    cd $DEST_DIR/$DEST_ROOT/libexec/gcc/$t-apple-darwin$DARWIN_VERS/$VERS/
-    rm libllvmgcc.dylib
-    ln -s ../../libllvmgcc.dylib
-  done
-fi
-# LLVM LOCAL end
-
+find $DEST_DIR -name \*.a -print | xargs strip -SX || exit 1
+find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
 chgrp -h -R wheel $DEST_DIR
 chgrp -R wheel $DEST_DIR





More information about the llvm-commits mailing list